// Created by the Microchip USBConfig Utility, Version 2.7.1.0, 4/6/2014, 16:36:46

#ifndef _usb_config_h_
#define _usb_config_h_

#define _USB_CONFIG_VERSION_MAJOR 2
#define _USB_CONFIG_VERSION_MINOR 7
#define _USB_CONFIG_VERSION_DOT   1
#define _USB_CONFIG_VERSION_BUILD 0

// Supported USB Configurations
#define USB_SUPPORT_DEVICE

// Hardware Configuration
#define USB_PING_PONG_MODE          USB_PING_PONG__EP0_OUT_ONLY

// Peripheral Configuration
#define MY_VID                      0x04D8
#define MY_PID                      0x000A
#define USB_SPEED_OPTION            USB_FULL_SPEED
#define USB_INTERRUPT
#define USB_PULLUP_OPTION           USB_PULLUP_ENABLE
#define USB_TRANSCEIVER_OPTION      USB_INTERNAL_TRANSCEIVER
#define USB_EP0_BUFF_SIZE           8
#define USB_MAX_NUM_INT             (1+2)
#define USB_MAX_EP_NUMBER           (1+2)
#define USB_NUM_STRING_DESCRIPTORS  4

#define USB_USER_DEVICE_DESCRIPTOR         &device_dsc
#define USB_USER_DEVICE_DESCRIPTOR_INCLUDE extern ROM USB_DEVICE_DESCRIPTOR device_dsc
#define USB_USER_CONFIG_DESCRIPTOR         USB_CD_Ptr
#define USB_USER_CONFIG_DESCRIPTOR_INCLUDE extern ROM BYTE *ROM USB_CD_Ptr[]

// HID Function Configuration
#define USB_USE_HID
#define HID_INTF_ID             0x00
#define HID_EP                  1
#define HID_INT_IN_EP_SIZE      3
#define HID_INT_OUT_EP_SIZE     3
#define HID_NUM_OF_DSC          1
#define HID_RPT01_SIZE          28

// CDC Function Configuration
#define USB_USE_CDC
#define CDC_COMM_INTF_ID        0x01
#define CDC_COMM_EP             2
#define CDC_COMM_IN_EP_SIZE     8
#define CDC_DATA_INTF_ID        0x02
#define CDC_DATA_EP             3
#define CDC_DATA_IN_EP_SIZE     64
#define CDC_DATA_OUT_EP_SIZE    64

#define USB_CDC_CTS_ACTIVE_LEVEL    0
#define USB_CDC_RTS_ACTIVE_LEVEL    0
#define USB_CDC_DSR_ACTIVE_LEVEL    0
#define USB_CDC_DTR_ACTIVE_LEVEL    0

#define USB_CDC_SUPPORT_ABSTRACT_CONTROL_MANAGEMENT_CAPABILITIES_D1 //Set_Line_Coding, Set_Control_Line_State, Get_Line_Coding, and Serial_State commands
//#define USB_CDC_SUPPORT_ABSTRACT_CONTROL_MANAGEMENT_CAPABILITIES_D2 //Send_Break command

#define USB_CDC_SET_LINE_CODING_HANDLER mySetLineCodingHandler

//#define USB_CDC_SUPPORT_DSR_REPORTING   //Signal from UART peripheral device, to CDC/USB host.  Indicates UART peripheral is ready to receive data and/or commands.
//#define USB_CDC_SUPPORT_DTR_SIGNALING   //Signal sent from the USB/CDC host, down to the UART peripheral device
//#define USB_CDC_SUPPORT_HARDWARE_FLOW_CONTROL   //Implements RTS/CTS UART flow control.
//#define USB_CDC_CTS_ACTIVE_LEVEL    0
//#define USB_CDC_RTS_ACTIVE_LEVEL    0
//#define USB_CDC_DSR_ACTIVE_LEVEL    0
//#define USB_CDC_DTR_ACTIVE_LEVEL    0

#define USB_ENABLE_STATUS_STAGE_TIMEOUTS
#define USB_STATUS_STAGE_TIMEOUT     (BYTE)45

#endif

////#define USB_INTERRUPT_LEGACY_CALLBACKS
////#define USB_ENABLE_ALL_HANDLERS
////#define USB_ENABLE_SUSPEND_HANDLER
////#define USB_ENABLE_WAKEUP_FROM_SUSPEND_HANDLER
////#define USB_ENABLE_SOF_HANDLER
////#define USB_ENABLE_ERROR_HANDLER
////#define USB_ENABLE_OTHER_REQUEST_HANDLER
////#define USB_ENABLE_SET_DESCRIPTOR_HANDLER
////#define USB_ENABLE_INIT_EP_HANDLER
////#define USB_ENABLE_EP0_DATA_HANDLER
////#define USB_ENABLE_TRANSFER_COMPLETE_HANDLER

//#define USB_DISABLE_SOF_HANDLER
//#define USB_DISABLE_ERROR_HANDLER
//#define USB_DISABLE_SET_DESCRIPTOR_HANDLER
