#pragma once
/********************************************************************
 FileName:		Form1.h
 Dependencies:	Windows SDK during development.  When compiled, needs
                                .NET framework 3.5 redistributable to run
 Processor:		x86 
 Hardware:		Need a free USB port to connect USB peripheral device
 Compiler:  	Microsoft Visual C++ 2008 Express Edition (or better)
 Company:		Microchip Technology, Inc.

 Software License Agreement:

 The software supplied herewith by Microchip Technology Incorporated
 (the Company? for its PIC?Microcontroller is intended and
 supplied to you, the Companys customer, for use solely and
 exclusively with Microchip PIC Microcontroller products. The
 software is owned by the Company and/or its supplier, and is
 protected under applicable copyright laws. All rights are reserved.
 Any use in violation of the foregoing restrictions may subject the
 user to criminal sanctions under applicable laws, as well as to
 civil liability for the breach of the terms and conditions of this
 license.

 THIS SOFTWARE IS PROVIDED IN AN AS IS?CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

 ********************************************************************
 File Description:

 Change History:
  Rev   Date         Description
  1.0   06/11/2009   Initial release

This demonstrates the HID USB DLL interface.

The DLL has four functions:
void USBHIDClassInit (VID, PID, Size) - Sets the Vendor and Product Id used in the class.
                                      Also specifies the Report Size.  This must match
                                                                          the size specified in the devices report descriptor.

bool USBHIDWriteReport (buffer, len)  - Sends a buffer to the device.  len specifies the
                                      number of valid bytes in the buffer.  The data is 
                                                                          padded out to the report size with 0xFF.

bool USBHIDReadReport (buffer)        - Reads a packet from the device and returns it the
                                      buffer.  buffer[0] contains the first byte from the device.

bool IsConnected()                    - Checks with the OS to see if the device is connected
                                                                          (VID & PID specified by USBHIDClassInit).  Returns
                                                                          true if the device is enumerated.  This is an OS
                                                                          inquiry only and does not generate any traffic on the bus.

ReadReport and WriteReport functions use non-blocking IO calls.  That is the function
will return after one second even if the call fails.  The functions return a boolean indicating 
success or failure.  This allows the application to gracefully recover when the device is 
disconnected rather than hang.

 *********************************************************************************************/

namespace GenericHIDDLLSimpleDemo
{

    using namespace System;
    using namespace System::ComponentModel;
    using namespace System::Collections;
    using namespace System::Windows::Forms;
    using namespace System::Data;
    using namespace System::Drawing;
    using namespace HIDClass;

    /// <summary>
    /// Summary for Form1
    ///
    /// WARNING: If you change the name of this class, you will need to change the
    ///          'Resource File Name' property for the managed resource compiler tool
    ///          associated with all .resx files this class depends on.  Otherwise,
    ///          the designers will not be able to interact properly with localized
    ///          resources associated with this form.
    /// </summary>
    public ref class Form1 : public System::Windows::Forms::Form
    {

public:
        Form1(void)
        {
            InitializeComponent();
            MCHPHIDClass::USBHIDClassInit(0x4D8, 0x000A, 64);
            //
            //TODO: Add the constructor code here
            //
        }

protected:
        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        ~Form1()
        {
            if (components)
            {
                delete components;
            }
        }

protected:



        private : System::Windows::Forms::GroupBox^ groupBox1;
private:
        System::Windows::Forms::Label^ lblDeviceState;
private:
        System::Windows::Forms::Timer^ Timer1;





private:
        System::Windows::Forms::Label^ lab1;
private:
        System::Windows::Forms::Label^ lab2;

private:
        System::Windows::Forms::ProgressBar^ BarValueP16_VR1;
private:
        System::Windows::Forms::Label^ labStatusP16_BT1;
private:
        System::Windows::Forms::Button^ butTooggleP16_LED1;
private:
        System::Windows::Forms::Button^ butTooggleP16_LED2;

private:
        System::Windows::Forms::ProgressBar^ BarValueP24_VR1;
private:
        System::Windows::Forms::Label^ labStatusP24_BT1;
private:
        System::Windows::Forms::Label^ labStatusP24_BT2;
private:
        System::Windows::Forms::Button^ butTooggleP24_LED1;
private:
        System::Windows::Forms::Button^ butTooggleP24_LED2;
private:
        System::Windows::Forms::Button^ butTooggleP24_LED3;
private:
        System::Windows::Forms::Button^ butTooggleP24_LED4;
private:
        System::Windows::Forms::ProgressBar^ BarValueP24_CAP1;
private:
        System::Windows::Forms::ProgressBar^ BarValueP24_CAP2;
private:
        System::Windows::Forms::Label^ labValueP24_VR1;
private:
        System::Windows::Forms::Label^ labValueP24_CAP1;
private:
        System::Windows::Forms::Label^ labValueP24_CAP2;
private:
        System::Windows::Forms::Label^ labValueP16_VR1;







private:
        System::ComponentModel::IContainer^ components;

private:
        /// <summary>
        /// Required designer variable.
        /// </summary>


        #pragma region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        void InitializeComponent(void)
        {
            this->components = (gcnew System::ComponentModel::Container());
            this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
            this->lblDeviceState = (gcnew System::Windows::Forms::Label());
            this->Timer1 = (gcnew System::Windows::Forms::Timer(this->components));
            this->butTooggleP24_LED4 = (gcnew System::Windows::Forms::Button());
            this->butTooggleP24_LED3 = (gcnew System::Windows::Forms::Button());
            this->labStatusP24_BT2 = (gcnew System::Windows::Forms::Label());
            this->labStatusP24_BT1 = (gcnew System::Windows::Forms::Label());
            this->BarValueP24_VR1 = (gcnew System::Windows::Forms::ProgressBar());
            this->butTooggleP24_LED2 = (gcnew System::Windows::Forms::Button());
            this->butTooggleP24_LED1 = (gcnew System::Windows::Forms::Button());
            this->lab2 = (gcnew System::Windows::Forms::Label());
            this->labStatusP16_BT1 = (gcnew System::Windows::Forms::Label());
            this->BarValueP16_VR1 = (gcnew System::Windows::Forms::ProgressBar());
            this->butTooggleP16_LED2 = (gcnew System::Windows::Forms::Button());
            this->butTooggleP16_LED1 = (gcnew System::Windows::Forms::Button());
            this->lab1 = (gcnew System::Windows::Forms::Label());
            this->BarValueP24_CAP1 = (gcnew System::Windows::Forms::ProgressBar());
            this->BarValueP24_CAP2 = (gcnew System::Windows::Forms::ProgressBar());
            this->labValueP24_VR1 = (gcnew System::Windows::Forms::Label());
            this->labValueP24_CAP1 = (gcnew System::Windows::Forms::Label());
            this->labValueP24_CAP2 = (gcnew System::Windows::Forms::Label());
            this->labValueP16_VR1 = (gcnew System::Windows::Forms::Label());
            this->groupBox1->SuspendLayout();
            this->SuspendLayout();
            // 
            // groupBox1
            // 
            this->groupBox1->Controls->Add(this->lblDeviceState);
            this->groupBox1->Location = System::Drawing::Point(218, 12);
            this->groupBox1->Name = L"groupBox1";
            this->groupBox1->Size = System::Drawing::Size(125, 29);
            this->groupBox1->TabIndex = 4;
            this->groupBox1->TabStop = false;
            this->groupBox1->Text = L" Device State ";
            // 
            // lblDeviceState
            // 
            this->lblDeviceState->AutoSize = true;
            this->lblDeviceState->Location = System::Drawing::Point(14, 15);
            this->lblDeviceState->Name = L"lblDeviceState";
            this->lblDeviceState->Size = System::Drawing::Size(67, 12);
            this->lblDeviceState->TabIndex = 0;
            this->lblDeviceState->Text = L"Disconnected";
            // 
            // Timer1
            // 
            this->Timer1->Enabled = true;
            this->Timer1->Interval = 200;
            this->Timer1->Tick += gcnew System::EventHandler(this, &Form1::Timer1_Tick);
            // 
            // butTooggleP24_LED4
            // 
            this->butTooggleP24_LED4->Font = (gcnew System::Drawing::Font(L"sө", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
                                                                          static_cast<System::Byte > (136)));
            this->butTooggleP24_LED4->Location = System::Drawing::Point(266, 226);
            this->butTooggleP24_LED4->Name = L"butTooggleP24_LED4";
            this->butTooggleP24_LED4->Size = System::Drawing::Size(76, 23);
            this->butTooggleP24_LED4->TabIndex = 23;
            this->butTooggleP24_LED4->Text = L"Toggle LED4";
            this->butTooggleP24_LED4->UseVisualStyleBackColor = true;
            this->butTooggleP24_LED4->Click += gcnew System::EventHandler(this, &Form1::butTooggleP24_LED4_Click);
            // 
            // butTooggleP24_LED3
            // 
            this->butTooggleP24_LED3->Font = (gcnew System::Drawing::Font(L"sө", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
                                                                          static_cast<System::Byte > (136)));
            this->butTooggleP24_LED3->Location = System::Drawing::Point(184, 226);
            this->butTooggleP24_LED3->Name = L"butTooggleP24_LED3";
            this->butTooggleP24_LED3->Size = System::Drawing::Size(76, 23);
            this->butTooggleP24_LED3->TabIndex = 22;
            this->butTooggleP24_LED3->Text = L"Toggle LED3";
            this->butTooggleP24_LED3->UseVisualStyleBackColor = true;
            this->butTooggleP24_LED3->Click += gcnew System::EventHandler(this, &Form1::butTooggleP24_LED3_Click);
            // 
            // labStatusP24_BT2
            // 
            this->labStatusP24_BT2->AutoSize = true;
            this->labStatusP24_BT2->Location = System::Drawing::Point(103, 129);
            this->labStatusP24_BT2->Name = L"labStatusP24_BT2";
            this->labStatusP24_BT2->Size = System::Drawing::Size(79, 12);
            this->labStatusP24_BT2->TabIndex = 21;
            this->labStatusP24_BT2->Text = L"State: Unknown";
            // 
            // labStatusP24_BT1
            // 
            this->labStatusP24_BT1->AutoSize = true;
            this->labStatusP24_BT1->Location = System::Drawing::Point(18, 129);
            this->labStatusP24_BT1->Name = L"labStatusP24_BT1";
            this->labStatusP24_BT1->Size = System::Drawing::Size(79, 12);
            this->labStatusP24_BT1->TabIndex = 20;
            this->labStatusP24_BT1->Text = L"State: Unknown";
            // 
            // BarValueP24_VR1
            // 
            this->BarValueP24_VR1->BackColor = System::Drawing::SystemColors::ControlLight;
            this->BarValueP24_VR1->Cursor = System::Windows::Forms::Cursors::Default;
            this->BarValueP24_VR1->Location = System::Drawing::Point(20, 144);
            this->BarValueP24_VR1->Maximum = 4095;
            this->BarValueP24_VR1->Name = L"BarValueP24_VR1";
            this->BarValueP24_VR1->Size = System::Drawing::Size(287, 18);
            this->BarValueP24_VR1->TabIndex = 19;
            // 
            // butTooggleP24_LED2
            // 
            this->butTooggleP24_LED2->Font = (gcnew System::Drawing::Font(L"sө", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
                                                                          static_cast<System::Byte > (136)));
            this->butTooggleP24_LED2->Location = System::Drawing::Point(102, 226);
            this->butTooggleP24_LED2->Name = L"butTooggleP24_LED2";
            this->butTooggleP24_LED2->Size = System::Drawing::Size(76, 23);
            this->butTooggleP24_LED2->TabIndex = 18;
            this->butTooggleP24_LED2->Text = L"Toggle LED2";
            this->butTooggleP24_LED2->UseVisualStyleBackColor = true;
            this->butTooggleP24_LED2->Click += gcnew System::EventHandler(this, &Form1::butTooggleP24_LED2_Click);
            // 
            // butTooggleP24_LED1
            // 
            this->butTooggleP24_LED1->Font = (gcnew System::Drawing::Font(L"sө", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
                                                                          static_cast<System::Byte > (136)));
            this->butTooggleP24_LED1->Location = System::Drawing::Point(20, 226);
            this->butTooggleP24_LED1->Name = L"butTooggleP24_LED1";
            this->butTooggleP24_LED1->Size = System::Drawing::Size(76, 23);
            this->butTooggleP24_LED1->TabIndex = 17;
            this->butTooggleP24_LED1->Text = L"Toggle LED1";
            this->butTooggleP24_LED1->UseVisualStyleBackColor = true;
            this->butTooggleP24_LED1->Click += gcnew System::EventHandler(this, &Form1::butTooggleP24_LED1_Click);
            // 
            // lab2
            // 
            this->lab2->AutoSize = true;
            this->lab2->Font = (gcnew System::Drawing::Font(L"sө", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
                                                            static_cast<System::Byte > (136)));
            this->lab2->Location = System::Drawing::Point(8, 111);
            this->lab2->Name = L"lab2";
            this->lab2->Size = System::Drawing::Size(147, 13);
            this->lab2->TabIndex = 16;
            this->lab2->Text = L"PIC24FV16KM202 Side";
            // 
            // labStatusP16_BT1
            // 
            this->labStatusP16_BT1->AutoSize = true;
            this->labStatusP16_BT1->Location = System::Drawing::Point(19, 30);
            this->labStatusP16_BT1->Name = L"labStatusP16_BT1";
            this->labStatusP16_BT1->Size = System::Drawing::Size(79, 12);
            this->labStatusP16_BT1->TabIndex = 15;
            this->labStatusP16_BT1->Text = L"State: Unknown";
            // 
            // BarValueP16_VR1
            // 
            this->BarValueP16_VR1->Location = System::Drawing::Point(21, 45);
            this->BarValueP16_VR1->Maximum = 1023;
            this->BarValueP16_VR1->Name = L"BarValueP16_VR1";
            this->BarValueP16_VR1->Size = System::Drawing::Size(286, 18);
            this->BarValueP16_VR1->TabIndex = 14;
            // 
            // butTooggleP16_LED2
            // 
            this->butTooggleP16_LED2->Font = (gcnew System::Drawing::Font(L"sө", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
                                                                          static_cast<System::Byte > (136)));
            this->butTooggleP16_LED2->Location = System::Drawing::Point(102, 71);
            this->butTooggleP16_LED2->Name = L"butTooggleP16_LED2";
            this->butTooggleP16_LED2->Size = System::Drawing::Size(76, 23);
            this->butTooggleP16_LED2->TabIndex = 13;
            this->butTooggleP16_LED2->Text = L"Toggle LED2";
            this->butTooggleP16_LED2->UseVisualStyleBackColor = true;
            this->butTooggleP16_LED2->Click += gcnew System::EventHandler(this, &Form1::butTooggleP16_LED2_Click);
            // 
            // butTooggleP16_LED1
            // 
            this->butTooggleP16_LED1->Font = (gcnew System::Drawing::Font(L"sө", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
                                                                          static_cast<System::Byte > (136)));
            this->butTooggleP16_LED1->Location = System::Drawing::Point(20, 71);
            this->butTooggleP16_LED1->Name = L"butTooggleP16_LED1";
            this->butTooggleP16_LED1->Size = System::Drawing::Size(76, 23);
            this->butTooggleP16_LED1->TabIndex = 12;
            this->butTooggleP16_LED1->Text = L"Toggle LED1";
            this->butTooggleP16_LED1->UseVisualStyleBackColor = true;
            this->butTooggleP16_LED1->Click += gcnew System::EventHandler(this, &Form1::butTooggleP16_LED1_Click);
            // 
            // lab1
            // 
            this->lab1->AutoSize = true;
            this->lab1->Font = (gcnew System::Drawing::Font(L"sө", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
                                                            static_cast<System::Byte > (136)));
            this->lab1->Location = System::Drawing::Point(9, 12);
            this->lab1->Name = L"lab1";
            this->lab1->Size = System::Drawing::Size(108, 13);
            this->lab1->TabIndex = 10;
            this->lab1->Text = L"PIC16F1455 Side";
            // 
            // BarValueP24_CAP1
            // 
            this->BarValueP24_CAP1->Location = System::Drawing::Point(20, 168);
            this->BarValueP24_CAP1->Maximum = 4095;
            this->BarValueP24_CAP1->Name = L"BarValueP24_CAP1";
            this->BarValueP24_CAP1->Size = System::Drawing::Size(287, 16);
            this->BarValueP24_CAP1->TabIndex = 24;
            // 
            // BarValueP24_CAP2
            // 
            this->BarValueP24_CAP2->Location = System::Drawing::Point(20, 190);
            this->BarValueP24_CAP2->Maximum = 4095;
            this->BarValueP24_CAP2->Name = L"BarValueP24_CAP2";
            this->BarValueP24_CAP2->Size = System::Drawing::Size(287, 16);
            this->BarValueP24_CAP2->TabIndex = 25;
            // 
            // labValueP24_VR1
            // 
            this->labValueP24_VR1->AutoSize = true;
            this->labValueP24_VR1->Font = (gcnew System::Drawing::Font(L"sө", 9, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
                                                                       static_cast<System::Byte > (136)));
            this->labValueP24_VR1->Location = System::Drawing::Point(313, 147);
            this->labValueP24_VR1->Name = L"labValueP24_VR1";
            this->labValueP24_VR1->Size = System::Drawing::Size(29, 12);
            this->labValueP24_VR1->TabIndex = 26;
            this->labValueP24_VR1->Text = L"4095";
            this->labValueP24_VR1->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
            // 
            // labValueP24_CAP1
            // 
            this->labValueP24_CAP1->AutoSize = true;
            this->labValueP24_CAP1->Font = (gcnew System::Drawing::Font(L"sө", 9, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
                                                                        static_cast<System::Byte > (136)));
            this->labValueP24_CAP1->Location = System::Drawing::Point(313, 170);
            this->labValueP24_CAP1->Name = L"labValueP24_CAP1";
            this->labValueP24_CAP1->Size = System::Drawing::Size(29, 12);
            this->labValueP24_CAP1->TabIndex = 27;
            this->labValueP24_CAP1->Text = L"4095";
            this->labValueP24_CAP1->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
            // 
            // labValueP24_CAP2
            // 
            this->labValueP24_CAP2->AutoSize = true;
            this->labValueP24_CAP2->Font = (gcnew System::Drawing::Font(L"sө", 9, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
                                                                        static_cast<System::Byte > (136)));
            this->labValueP24_CAP2->Location = System::Drawing::Point(313, 192);
            this->labValueP24_CAP2->Name = L"labValueP24_CAP2";
            this->labValueP24_CAP2->Size = System::Drawing::Size(29, 12);
            this->labValueP24_CAP2->TabIndex = 28;
            this->labValueP24_CAP2->Text = L"4095";
            this->labValueP24_CAP2->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
            // 
            // labValueP16_VR1
            // 
            this->labValueP16_VR1->AutoSize = true;
            this->labValueP16_VR1->Font = (gcnew System::Drawing::Font(L"sө", 9, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
                                                                       static_cast<System::Byte > (136)));
            this->labValueP16_VR1->Location = System::Drawing::Point(313, 48);
            this->labValueP16_VR1->Name = L"labValueP16_VR1";
            this->labValueP16_VR1->Size = System::Drawing::Size(29, 12);
            this->labValueP16_VR1->TabIndex = 29;
            this->labValueP16_VR1->Text = L"4095";
            this->labValueP16_VR1->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
            // 
            // Form1
            // 
            this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
            this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
            this->ClientSize = System::Drawing::Size(352, 259);
            this->Controls->Add(this->labValueP16_VR1);
            this->Controls->Add(this->labValueP24_CAP2);
            this->Controls->Add(this->labValueP24_CAP1);
            this->Controls->Add(this->labValueP24_VR1);
            this->Controls->Add(this->BarValueP24_CAP2);
            this->Controls->Add(this->BarValueP24_CAP1);
            this->Controls->Add(this->butTooggleP24_LED4);
            this->Controls->Add(this->butTooggleP24_LED3);
            this->Controls->Add(this->groupBox1);
            this->Controls->Add(this->labStatusP24_BT2);
            this->Controls->Add(this->BarValueP16_VR1);
            this->Controls->Add(this->labStatusP24_BT1);
            this->Controls->Add(this->lab1);
            this->Controls->Add(this->BarValueP24_VR1);
            this->Controls->Add(this->butTooggleP16_LED1);
            this->Controls->Add(this->butTooggleP24_LED2);
            this->Controls->Add(this->butTooggleP16_LED2);
            this->Controls->Add(this->butTooggleP24_LED1);
            this->Controls->Add(this->labStatusP16_BT1);
            this->Controls->Add(this->lab2);
            this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
            this->Name = L"Form1";
            this->Text = L"APP-ESS14-1 Composite Demo Demo";
            this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
            this->groupBox1->ResumeLayout(false);
            this->groupBox1->PerformLayout();
            this->ResumeLayout(false);
            this->PerformLayout();

        }
        #pragma endregion

private:
        System::Void Timer1_Tick(System::Object^ sender, System::EventArgs^ e)
        {

            unsigned char InputPacketBuffer[64];
            unsigned char OutputPacketBuffer[64];

            unsigned int Temporary;


            if (MCHPHIDClass::USBHIDIsConnected() == true)
            {
                lblDeviceState->Text = "Connected";
            }
            else
            {
                lblDeviceState->Text = "Disconnected";
            }

            OutputPacketBuffer[0] = 0x82; // Command Code

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 1) == true)
            {
                MCHPHIDClass::USBHIDReadReport(InputPacketBuffer);

                BarValueP16_VR1->Value = InputPacketBuffer[5] * 256 + InputPacketBuffer[4];
                labValueP16_VR1->Text = System::Convert::ToString(InputPacketBuffer[5] * 256 + InputPacketBuffer[4]);
            }

            OutputPacketBuffer[0] = 0x83; // Command Code

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 1) == true)
            {
                MCHPHIDClass::USBHIDReadReport(InputPacketBuffer);

                if (InputPacketBuffer[4] == 1)
                    labStatusP16_BT1->Text = "State: Pressed";
                else
                    labStatusP16_BT1->Text = "State: Not Pressed";
            }

            OutputPacketBuffer[0] = 0xA1; // Command Code
            OutputPacketBuffer[1] = 0x00; // 
            OutputPacketBuffer[2] = 0x00; // User Define Code1
            OutputPacketBuffer[3] = 0x01; // User Define Code2
            OutputPacketBuffer[4] = 0x40; // Slave Address
            OutputPacketBuffer[5] = 0x08; // Address Low Byte
            OutputPacketBuffer[6] = 0x00; // Address High Byte
            OutputPacketBuffer[7] = 0x00;

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 8) == true)
            {
                MCHPHIDClass::USBHIDReadReport(InputPacketBuffer);

                if (InputPacketBuffer[0] == 0xA1 && InputPacketBuffer[3] == 0x01)
                {
                    if (InputPacketBuffer[4] == 0x01)
                        labStatusP24_BT1->Text = "State: Pressed";
                    else
                        labStatusP24_BT1->Text = "State: Not Pressed";
                }
            }

            OutputPacketBuffer[0] = 0xA1; // Command Code
            OutputPacketBuffer[1] = 0x00; // 
            OutputPacketBuffer[2] = 0x00; // User Define Code1
            OutputPacketBuffer[3] = 0x02; // User Define Code2
            OutputPacketBuffer[4] = 0x40; // Slave Address
            OutputPacketBuffer[5] = 0x09; // Address Low Byte
            OutputPacketBuffer[6] = 0x00; // Address High Byte
            OutputPacketBuffer[7] = 0x00;

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 8) == true)
            {
                MCHPHIDClass::USBHIDReadReport(InputPacketBuffer);

                if (InputPacketBuffer[0] == 0xA1 && InputPacketBuffer[3] == 0x02)
                {
                    if (InputPacketBuffer[4] == 0x01)
                        labStatusP24_BT2->Text = "State: Pressed";
                    else
                        labStatusP24_BT2->Text = "State: Not Pressed";
                }
            }

            OutputPacketBuffer[0] = 0xA1; // Command Code
            OutputPacketBuffer[1] = 0x00; // 
            OutputPacketBuffer[2] = 0x00; // User Define Code1
            OutputPacketBuffer[3] = 0x03; // User Define Code2
            OutputPacketBuffer[4] = 0x40; // Slave Address
            OutputPacketBuffer[5] = 0x00; // Address Low Byte
            OutputPacketBuffer[6] = 0x00; // Address High Byte
            OutputPacketBuffer[7] = 0x00;

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 8) == true)
            {
                MCHPHIDClass::USBHIDReadReport(InputPacketBuffer);

                if (InputPacketBuffer[0] == 0xA1 && InputPacketBuffer[3] == 0x03)
                    Temporary = InputPacketBuffer[4];
            }

            OutputPacketBuffer[0] = 0xA1; // Command Code
            OutputPacketBuffer[1] = 0x00; // 
            OutputPacketBuffer[2] = 0x00; // User Define Code1
            OutputPacketBuffer[3] = 0x04; // User Define Code2
            OutputPacketBuffer[4] = 0x40; // Slave Address
            OutputPacketBuffer[5] = 0x01; // Address Low Byte
            OutputPacketBuffer[6] = 0x00; // Address High Byte
            OutputPacketBuffer[7] = 0x00;

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 8) == true)
            {
                MCHPHIDClass::USBHIDReadReport(InputPacketBuffer);

                if (InputPacketBuffer[0] == 0xA1 && InputPacketBuffer[3] == 0x04)
                {
                    if (InputPacketBuffer[4]*256 + Temporary <= 4095)
                    {
                        BarValueP24_VR1->Value = InputPacketBuffer[4]*256 + Temporary;
                        labValueP24_VR1->Text = System::Convert::ToString(InputPacketBuffer[4]*256 + Temporary);
                    }
                    Temporary = 0;
                }
            }


            OutputPacketBuffer[0] = 0xA1; // Command Code
            OutputPacketBuffer[1] = 0x00; // 
            OutputPacketBuffer[2] = 0x00; // User Define Code1
            OutputPacketBuffer[3] = 0x05; // User Define Code2
            OutputPacketBuffer[4] = 0x40; // Slave Address
            OutputPacketBuffer[5] = 0x02; // Address Low Byte
            OutputPacketBuffer[6] = 0x00; // Address High Byte
            OutputPacketBuffer[7] = 0x00;

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 8) == true)
            {
                MCHPHIDClass::USBHIDReadReport(InputPacketBuffer);

                if (InputPacketBuffer[0] == 0xA1 && InputPacketBuffer[3] == 0x05)
                    Temporary = InputPacketBuffer[4];
            }

            OutputPacketBuffer[0] = 0xA1; // Command Code
            OutputPacketBuffer[1] = 0x00; // 
            OutputPacketBuffer[2] = 0x00; // User Define Code1
            OutputPacketBuffer[3] = 0x06; // User Define Code2
            OutputPacketBuffer[4] = 0x40; // Slave Address
            OutputPacketBuffer[5] = 0x03; // Address Low Byte
            OutputPacketBuffer[6] = 0x00; // Address High Byte
            OutputPacketBuffer[7] = 0x00;

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 8) == true)
            {
                MCHPHIDClass::USBHIDReadReport(InputPacketBuffer);

                if (InputPacketBuffer[0] == 0xA1 && InputPacketBuffer[3] == 0x06)
                {
                    if (InputPacketBuffer[4]*256 + Temporary <= 4095)
                    {
                        BarValueP24_CAP1->Value = InputPacketBuffer[4]*256 + Temporary;
                        labValueP24_CAP1->Text = System::Convert::ToString(InputPacketBuffer[4]*256 + Temporary);
                    }
                    Temporary = 0;
                }


            }

            OutputPacketBuffer[0] = 0xA1; // Command Code
            OutputPacketBuffer[1] = 0x00; // 
            OutputPacketBuffer[2] = 0x00; // User Define Code1
            OutputPacketBuffer[3] = 0x07; // User Define Code2
            OutputPacketBuffer[4] = 0x40; // Slave Address
            OutputPacketBuffer[5] = 0x04; // Address Low Byte
            OutputPacketBuffer[6] = 0x00; // Address High Byte
            OutputPacketBuffer[7] = 0x00;

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 8) == true)
            {
                MCHPHIDClass::USBHIDReadReport(InputPacketBuffer);

                if (InputPacketBuffer[0] == 0xA1 && InputPacketBuffer[3] == 0x07)
                    Temporary = InputPacketBuffer[4];
            }

            OutputPacketBuffer[0] = 0xA1; // Command Code
            OutputPacketBuffer[1] = 0x00; // 
            OutputPacketBuffer[2] = 0x00; // User Define Code1
            OutputPacketBuffer[3] = 0x08; // User Define Code2
            OutputPacketBuffer[4] = 0x40; // Slave Address
            OutputPacketBuffer[5] = 0x05; // Address Low Byte
            OutputPacketBuffer[6] = 0x00; // Address High Byte
            OutputPacketBuffer[7] = 0x00;

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 8) == true)
            {
                MCHPHIDClass::USBHIDReadReport(InputPacketBuffer);

                if (InputPacketBuffer[0] == 0xA1 && InputPacketBuffer[3] == 0x08)
                {
                    if (InputPacketBuffer[4]*256 + Temporary <= 4095)
                    {
                        BarValueP24_CAP2->Value = InputPacketBuffer[4]*256 + Temporary;
                        labValueP24_CAP2->Text = System::Convert::ToString(InputPacketBuffer[4]*256 + Temporary);

                    }
                    Temporary = 0;
                }
            }


        }

private:
        System::Void Form1_Load(System::Object^ sender, System::EventArgs^ e)
        {
        }

private:
        System::Void butTooggleP24_LED1_Click(System::Object^ sender, System::EventArgs^ e)
        {

            static unsigned char i = 0;
            unsigned char OutputPacketBuffer[64];

            OutputPacketBuffer[0] = 0xA0; // Command Code
            OutputPacketBuffer[1] = 0x00; // 
            OutputPacketBuffer[2] = 0x00; // User Define Code1
            OutputPacketBuffer[3] = 0x01; // User Define Code2
            OutputPacketBuffer[4] = 0x40; // Slave Address
            OutputPacketBuffer[5] = 0x10; // Address Low Byte
            OutputPacketBuffer[6] = 0x00; // Address High Byte
            i ^= 0x01;
            OutputPacketBuffer[7] = i;

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 8) == true)
                lblDeviceState->Text = "Connected";
            else
                lblDeviceState->Text = "Disconnected";
        }

private:
        System::Void butTooggleP24_LED2_Click(System::Object^ sender, System::EventArgs^ e)
        {

            static unsigned char i = 0;
            unsigned char OutputPacketBuffer[64];

            OutputPacketBuffer[0] = 0xA0; // Command Code
            OutputPacketBuffer[1] = 0x00; // 
            OutputPacketBuffer[2] = 0x00; // User Define Code1
            OutputPacketBuffer[3] = 0x02; // User Define Code2
            OutputPacketBuffer[4] = 0x40; // Slave Address
            OutputPacketBuffer[5] = 0x11; // Address Low Byte
            OutputPacketBuffer[6] = 0x00; // Address High Byte
            i ^= 0x01;
            OutputPacketBuffer[7] = i;

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 8) == true)
                lblDeviceState->Text = "Connected";
            else
                lblDeviceState->Text = "Disconnected";
        }

private:
        System::Void butTooggleP24_LED3_Click(System::Object^ sender, System::EventArgs^ e)
        {

            static unsigned char i = 0;
            unsigned char OutputPacketBuffer[64];

            OutputPacketBuffer[0] = 0xA0; // Command Code
            OutputPacketBuffer[1] = 0x00; // 
            OutputPacketBuffer[2] = 0x00; // User Define Code1
            OutputPacketBuffer[3] = 0x03; // User Define Code2
            OutputPacketBuffer[4] = 0x40; // Slave Address
            OutputPacketBuffer[5] = 0x12; // Address Low Byte
            OutputPacketBuffer[6] = 0x00; // Address High Byte
            i ^= 0x01;
            OutputPacketBuffer[7] = i;

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 8) == true)
                lblDeviceState->Text = "Connected";
            else
                lblDeviceState->Text = "Disconnected";
        }

private:
        System::Void butTooggleP24_LED4_Click(System::Object^ sender, System::EventArgs^ e)
        {

            static unsigned char i = 0;
            unsigned char OutputPacketBuffer[64];

            OutputPacketBuffer[0] = 0xA0; // Command Code
            OutputPacketBuffer[1] = 0x00; // 
            OutputPacketBuffer[2] = 0x00; // User Define Code1
            OutputPacketBuffer[3] = 0x04; // User Define Code2
            OutputPacketBuffer[4] = 0x40; // Slave Address
            OutputPacketBuffer[5] = 0x13; // Address Low Byte
            OutputPacketBuffer[6] = 0x00; // Address High Byte
            i ^= 0x01;
            OutputPacketBuffer[7] = i;

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 8) == true)
                lblDeviceState->Text = "Connected";
            else
                lblDeviceState->Text = "Disconnected";
        }

private:
        System::Void butTooggleP16_LED1_Click(System::Object^ sender, System::EventArgs^ e)
        {

            unsigned char OutputPacketBuffer[64];

            OutputPacketBuffer[0] = 0x80;

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 1) == true)
                lblDeviceState->Text = "Connected";
            else
                lblDeviceState->Text = "Disconnected";
        }

private:
        System::Void butTooggleP16_LED2_Click(System::Object^ sender, System::EventArgs^ e)
        {

            unsigned char OutputPacketBuffer[64];

            OutputPacketBuffer[0] = 0x81;

            if (MCHPHIDClass::USBHIDWriteReport(OutputPacketBuffer, 1) == true)
                lblDeviceState->Text = "Connected";
            else
                lblDeviceState->Text = "Disconnected";
        }
    };
}
